import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import geom.DPoint;
import geom.Ferguson;
import geom.Line;
import geom.Point;
import geom.Rectangle;
import geom.RotateGroup;
import geom.TransformGroup;
import geom.TranslateGroup;
import gui.MainFrame;
import gui.MyInputAdapter;

import javax.media.j3d.Transform3D;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import shapes.Road;
import shapes.Pattern;

import core.Core;

import drawing.Enviroment;
import drawing.PaintBox;


public class Main {


	public static void main(String[] args) {
    	
    	try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (UnsupportedLookAndFeelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
    	
    	PaintBox paintBox = new PaintBox(Enviroment.PIXELS_PER_UNIT);
    	MainFrame gui = new MainFrame(paintBox);
    	
    	Core core = new Core(paintBox, gui);
    	
    	MyInputAdapter inputAdapter = new MyInputAdapter(paintBox, core);
    	
    	gui.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	
    	//gui.pack();
    	gui.setVisible(true);
    	
    	//paintBox.updateTransform();
    }
}
