package geom;
import java.awt.Color;
import java.util.ArrayList;

import javax.vecmath.Vector3d;

import drawing.Enviroment;

public class Ferguson extends Curve {
	

	public Ferguson(Color color, DPoint start, DPoint end, int subDiv) {
		
		super(color, start, end, subDiv);
	}

	public ArrayList<Point> generatePoints() {
		
		ArrayList<Point> outputPoints = new ArrayList<Point>();
		
		for (int i = 0; i < subDiv; i++) {
			
			double t = (double)i / subDiv;
			double t3 = t*t*t;
			double t2 = t*t;
			
			double F0 = 2*t3 - 3*t2 + 1;
			double F1 = -2*t3 + 3*t2;
			double F2 = t3 -2*t2 + t;
			double F3 = t3 - t2;
			
			Vector3d X = new Vector3d();
			
			Vector3d tmp = new Vector3d(start.position);
			tmp.scale(F0);
			X.add(tmp);
			
			tmp.set(end.position);
			tmp.scale(F1);
			X.add(tmp);
			
			tmp.set(start.getDerivative());
			tmp.scale(F2 * Enviroment.DERIV_MUL);
			X.add(tmp);
			
			tmp.set(end.getDerivative());
			tmp.scale(F3 * Enviroment.DERIV_MUL);
			X.add(tmp);
			
			outputPoints.add(new Point(X));
		}
		
		outputPoints.add(end);
		
		return outputPoints;
	}

	@Override
	public ArrayList<Vector3d> generateTangents() {
		// TODO Auto-generated method stub
		return null;
	}
}
