package geom;
import java.awt.Color;
import java.awt.Graphics;

import javax.vecmath.Matrix4d;

import drawing.Drawable;


public class Line extends Shape {
	
	public Point p1;
	public Point p2;
	
	public Line(Color color, Point p1, Point p2) {
		super(color);
		this.p1 = p1;
		this.p2 = p2;
	}

	public Line(Point p1, Point p2) {
		super();
		this.p1 = p1;
		this.p2 = p2;
	}
	
	public void draw(Graphics g) {
		
		super.draw(g);
		
		g.drawLine(p1.finalX, p1.finalY, p2.finalX, p2.finalY);
	}
	
	public void transform(Matrix4d windowTransform) {

		p1.transform(windowTransform);
		p2.transform(windowTransform);
	}
}
