package geom;
import java.awt.Color;
import java.awt.Graphics;
import java.io.Serializable;
import java.util.Observable;

import drawing.Drawable;

public abstract class Shape extends Observable implements Drawable, Serializable {
	
	public void draw(Graphics g) {
		
		g.setColor(this.color);
	}

	private Color color;
	private int zIndex = 0;
	
	public Shape() {
		super();
		color = new Color(0,0,0);
	}

	public Shape(Color color) {
		super();
		// TODO Auto-generated constructor stub
		this.color = color;
	}

	public Color getColor() {
		return color;
	}

	public void setColor(Color color) {
		this.color = color;
	}

	public int getZIndex() {
		return zIndex;
	}

	public void setZIndex(int index) {
		zIndex = index;
	}
	
	public void attachObservers() {
		
	}
}
