package geom;

import java.awt.Graphics;
import java.util.ArrayList;
import java.util.Arrays;

import javax.media.j3d.Transform3D;
import javax.vecmath.Matrix4d;

public class TransformGroup extends Shape {
	
	public Point pivot;
	
	protected MyTransform3D transform;
	protected ArrayList<Shape> shapes = new ArrayList<Shape>();

	public TransformGroup(MyTransform3D transform) {
		super();
		this.transform = transform;
		
		this.pivot = new Point(0,0);
	}

	@Override
	public void draw(Graphics g) {
		
		for (Shape s : this.shapes) {
			
			s.draw(g);
		}
	}

	public void transform(Matrix4d windowTransform) {
		
		this.pivot.transform(windowTransform);
		
		Matrix4d result = new Matrix4d(windowTransform);
		Matrix4d tmp = new Matrix4d();
		transform.get(tmp);
		
		result.mul(tmp);
		
		for (Shape s : this.shapes) {
			
			s.transform(result);
		}
	}
	
	public void addShape(Shape s) {
		
		this.shapes.add(s);

		Shape[] array = this.shapes.toArray(new Shape[1]);
		Arrays.sort(array, new ShapeComparator());

		this.shapes.clear();

		for (int i = 0; i < array.length; i++) {

			this.shapes.add(array[i]);
		}
	}

	public ArrayList<Shape> getShapes() {
		return shapes;
	}

}
