package geom;
import java.awt.Graphics;
import java.util.Observable;
import java.util.Observer;

import javax.media.j3d.Transform3D;
import javax.vecmath.Matrix4d;
import javax.vecmath.Point3d;
import javax.vecmath.Vector3d;

import drawing.Catchable;



public class TranslateGroup extends TransformGroup implements Observer, Catchable {
	
	public Point referencePoint = new Point(0,0);
	
	public void update(Observable o, Object arg) {
		
		this.transform.setTranslation(this.referencePoint.position);
		
		//after move event
		if (arg == o) {
			
			setChanged();
			notifyObservers(arg);
		}
	}

	public TranslateGroup(double x, double y) {
		
		super(new MyTransform3D());
		this.transform.setIdentity();
		
		this.referencePoint.position.x = x;
		this.referencePoint.position.y = y;
		
		attachObservers();
	}

	public Catchable isCatch(double x, double y) {
		
		if ( referencePoint.isCatch(x, y) != null ) {
			
			return referencePoint;
		}
		else {
			
			for (Shape s : this.shapes) {
				
				if ( s instanceof Catchable ) {
					
					Point3d point = new Point3d(x, y, 0);
					
					Transform3D inverted = new Transform3D(this.transform);
					inverted.invert();
					inverted.transform(point);
			
					Catchable clicked = ((Catchable)s).isCatch(point.x, point.y);
					
					if ( clicked != null) {
						
						return clicked;
					}
				}
			}
			return null;
		}
	}

	@Override
	public void draw(Graphics g) {
		// TODO Auto-generated method stub
		super.draw(g);
		this.referencePoint.draw(g);
	}

	@Override
	public void transform(Matrix4d windowTransform) {
		// TODO Auto-generated method stub
		super.transform(windowTransform);
		
		this.referencePoint.transform(windowTransform);
	}

	@Override
	public void attachObservers() {
		
		this.referencePoint.addObserver(this);
		this.update(null, null);
	}
}