package gui;

import java.awt.GridBagLayout;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Font;
import java.awt.Color;
import java.awt.Dimension;
import javax.swing.JCheckBox;
import java.awt.GridBagConstraints;
import java.awt.Rectangle;
import java.awt.Point;

public class ExportOptions extends JPanel {

	private static final long serialVersionUID = 1L;
	private JCheckBox mirrorCheckBox = null;
	private JCheckBox randomizeCheckBox = null;

	/**
	 * This is the default constructor
	 */
	public ExportOptions() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.anchor = GridBagConstraints.NORTH;
		gridBagConstraints2.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints2.weightx = 1.0;
		gridBagConstraints2.weighty = 1.0;
		gridBagConstraints2.gridy = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
		gridBagConstraints.weightx = 1.0;
		gridBagConstraints.anchor = GridBagConstraints.NORTH;
		gridBagConstraints.weighty = 0.0;
		gridBagConstraints.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setBorder(BorderFactory.createTitledBorder(null, "Export Options", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Tahoma", Font.PLAIN, 11), new Color(0, 70, 213)));
		this.setLocation(new Point(0, 0));
		this.setSize(new Dimension(180, 80));
		this.add(getMirrorCheckBox(), gridBagConstraints);
		this.add(getRandomizeCheckBox(), gridBagConstraints2);
	}

	/**
	 * This method initializes mirrorCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getMirrorCheckBox() {
		if (mirrorCheckBox == null) {
			mirrorCheckBox = new JCheckBox();
			mirrorCheckBox.setText("Generate mirror patterns");
			mirrorCheckBox.setSelected(true);
		}
		return mirrorCheckBox;
	}

	/**
	 * This method initializes randomizeCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getRandomizeCheckBox() {
		if (randomizeCheckBox == null) {
			randomizeCheckBox = new JCheckBox();
			randomizeCheckBox.setText("Randomize patterns");
		}
		return randomizeCheckBox;
	}

}
