/*
 * Created on 20.2.2008
 *
 */
package gui;

import javax.swing.JPanel;
import javax.swing.JFrame;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import java.awt.Font;
import java.awt.Color;
import java.awt.Insets;
import java.awt.event.ComponentEvent;

import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTabbedPane;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JComboBox;
import javax.swing.JSlider;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.ListSelectionModel;
import javax.swing.JScrollPane;
import javax.swing.border.BevelBorder;

import drawing.Enviroment;
import drawing.PaintBox;
import javax.swing.JToggleButton;

import core.Core;
import core.Utils;
import java.awt.BorderLayout;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Observable;
import java.util.Observer;
import javax.swing.ImageIcon;
import javax.swing.JToolBar;

public class MainFrame extends JFrame implements Observer {
	
	public void updateSummary() {
		
		if ( Core.instance.selectedPattern != null ) {
			
			ArrayList<Object> data = new ArrayList<Object>(Core.instance.selectedPattern.arcs);
			data.add("Velocity: " + 
					Enviroment.NUM_FORMAT.format(Utils.msToKmh(Core.instance.selectedPattern.getVelocity().length())) + " km/h");
			data.add("Distance: " + Enviroment.NUM_FORMAT.format(Core.instance.selectedPattern.distance) + " m");
			
			inputList.setListData(data.toArray());
		}
	}

	public void update(Observable o, Object arg) {
		
		patternList.repaint();
		
		updateSummary();
	}

	private static final long serialVersionUID = 1L;
	
	final JFileChooser fileChooser = new JFileChooser();

	private JPanel jContentPane = null;

	private JPanel drawPanel = null;

	private JPanel toolPanel = null;

	private JTabbedPane jTabbedPane = null;

	private JPanel curvePanel = null;

	private JPanel vehiclePanel = null;

	private JButton newRoadButton = null;

	private JButton deleteRoadButton = null;

	private JList roadList = null;

	private JList inputList = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private JComboBox roadComboBox = null;

	private JLabel jLabel4 = null;

	private JList patternList = null;

	private JPanel roadsPanel = null;

	private JPanel jPanel = null;

	private JPanel jPanel1 = null;

	private JPanel jPanel2 = null;

	private JLabel jLabel = null;

	private JButton newPatternButton = null;

	private JButton deletePatternButton = null;

	private JSlider throttleSlider = null;

	private JSlider steerSlider = null;

	private JScrollPane jScrollPane = null;
	
	private JScrollPane jScrollPane1 = null;

	private JButton exportButton = null;

	private JButton saveButton = null;

	private JButton OpenButton = null;
	
	private PaintBox paintBox;

	private JToggleButton pointsToggleButton = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel5 = null;

	private JLabel jLabel6 = null;

	private JLabel jLabel7 = null;

	private JToolBar jToolBar = null;

	private JButton upButton = null;

	private JButton downButton = null;

	private JSlider jSlider = null;

	private JSlider zoomSlider = null;

	private JLabel jLabel8 = null;

	/**
	 * This is the default constructor
	 */
	public MainFrame(PaintBox paintBox) {
		super();
		
		this.paintBox = paintBox;
		
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(808, 750);
		this.setContentPane(getJContentPane());
		this.setPreferredSize(new Dimension(800, 600));
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setTitle("TrainSet Generator 1.1");
		this.setVisible(true);
		
		GridBagConstraints gbDraw = new GridBagConstraints();
    	gbDraw.fill = GridBagConstraints.BOTH;
    	gbDraw.weightx = 1;
    	gbDraw.weighty = 1;
    	
    	this.getDrawPanel().add(paintBox, gbDraw);
    	
    	paintBox.addComponentListener(new java.awt.event.ComponentAdapter() {
			public void componentResized(java.awt.event.ComponentEvent e) {
				
				paintBox.updateTransform();
				paintBox.repaint();
			}
		});
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 1;
			gridBagConstraints1.weightx = 0.1;
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.weighty = 1.0;
			gridBagConstraints1.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints1.ipadx = 0;
			gridBagConstraints1.gridy = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints.ipadx = 0;
			gridBagConstraints.gridy = 0;
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.setPreferredSize(new Dimension(800, 600));
			jContentPane.add(getToolPanel(), gridBagConstraints1);
			jContentPane.add(getDrawPanel(), gridBagConstraints);
		}
		return jContentPane;
	}

	/**
     * This method initializes drawPanel	
     * 	
     * @return javax.swing.JPanel	
     */
    public JPanel getDrawPanel() {
    	if (drawPanel == null) {
    		drawPanel = new JPanel();
    		drawPanel.setLayout(new GridBagLayout());
    		drawPanel.setPreferredSize(new Dimension(600, 600));
    		drawPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
    	}
    	return drawPanel;
    }

	/**
     * This method initializes toolPanel	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getToolPanel() {
    	if (toolPanel == null) {
    		GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
    		gridBagConstraints21.gridx = 0;
    		gridBagConstraints21.insets = new Insets(0, 5, 0, 0);
    		gridBagConstraints21.gridy = 1;
    		jLabel8 = new JLabel();
    		jLabel8.setText("Zoom");
    		GridBagConstraints gridBagConstraints20 = new GridBagConstraints();
    		gridBagConstraints20.fill = GridBagConstraints.BOTH;
    		gridBagConstraints20.gridx = 1;
    		gridBagConstraints20.gridy = 1;
    		gridBagConstraints20.insets = new Insets(0, 0, 0, 5);
    		gridBagConstraints20.weightx = 1.0;
    		jLabel4 = new JLabel();
    		jLabel4.setText("Steering:");
    		jLabel2 = new JLabel();
    		jLabel2.setText("Throttle:");
    		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
    		gridBagConstraints2.fill = GridBagConstraints.BOTH;
    		gridBagConstraints2.gridy = 0;
    		gridBagConstraints2.weightx = 1.0;
    		gridBagConstraints2.weighty = 1.0;
    		gridBagConstraints2.insets = new Insets(0, 5, 0, 0);
    		gridBagConstraints2.gridwidth = 2;
    		gridBagConstraints2.gridx = 0;
    		toolPanel = new JPanel();
    		toolPanel.setLayout(new GridBagLayout());
    		toolPanel.setPreferredSize(new Dimension(250, 0));
    		toolPanel.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
    		toolPanel.add(getJTabbedPane(), gridBagConstraints2);
    		toolPanel.add(getZoomSlider(), gridBagConstraints20);
    		toolPanel.add(jLabel8, gridBagConstraints21);
    	}
    	return toolPanel;
    }

	/**
     * This method initializes jTabbedPane	
     * 	
     * @return javax.swing.JTabbedPane	
     */
    private JTabbedPane getJTabbedPane() {
    	if (jTabbedPane == null) {
    		jTabbedPane = new JTabbedPane();
    		jTabbedPane.addTab("Roads", null, getCurvePanel(), null);
    		jTabbedPane.addTab("Patterns", null, getVehiclePanel(), null);
    		jTabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {
    			public void stateChanged(javax.swing.event.ChangeEvent e) {
    				
    				if ( pointsToggleButton.isSelected() ) {
    					
    					pointsToggleButton.doClick();
    				}
    				
    				Core.instance.isRoadEditing = jTabbedPane.getSelectedIndex() == 0;
    				
    				if ( jTabbedPane.getSelectedIndex() == 0) {
    					
    					Core.instance.switchRoad(roadList.getSelectedIndex());
    				}
    				else if ( jTabbedPane.getSelectedIndex() == 1) {
    					
    					if ( Core.instance.selectedPattern != null ) {
    						
    						Core.instance.switchRoad(Core.instance.session.roads.indexOf(Core.instance.selectedPattern.road));
    					}
    					else {
    						
    						Core.instance.switchRoad(roadComboBox.getSelectedIndex());
    					}
    					
    					Core.instance.recomputePatterns();
    				}  				
    				Core.instance.paintBox.repaint();
    			}
    		});
    	}
    	return jTabbedPane;
    }

	/**
     * This method initializes curvePanel	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getCurvePanel() {
    	if (curvePanel == null) {
    		GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
    		gridBagConstraints5.gridx = 2;
    		gridBagConstraints5.insets = new Insets(3, 0, 0, 0);
    		gridBagConstraints5.gridy = 0;
    		GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
    		gridBagConstraints6.gridx = 0;
    		gridBagConstraints6.fill = GridBagConstraints.BOTH;
    		gridBagConstraints6.weightx = 1.0;
    		gridBagConstraints6.weighty = 1.0;
    		gridBagConstraints6.gridwidth = 3;
    		gridBagConstraints6.gridy = 3;
    		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
    		gridBagConstraints4.gridx = 1;
    		gridBagConstraints4.fill = GridBagConstraints.HORIZONTAL;
    		gridBagConstraints4.weightx = 0.5;
    		gridBagConstraints4.insets = new Insets(3, 0, 0, 0);
    		gridBagConstraints4.gridy = 0;
    		GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
    		gridBagConstraints3.gridx = 0;
    		gridBagConstraints3.fill = GridBagConstraints.HORIZONTAL;
    		gridBagConstraints3.weightx = 0.5;
    		gridBagConstraints3.insets = new Insets(3, 0, 0, 0);
    		gridBagConstraints3.gridy = 0;
    		curvePanel = new JPanel();
    		curvePanel.setLayout(new GridBagLayout());
    		curvePanel.setName("");
    		curvePanel.add(getNewRoadButton(), gridBagConstraints3);
    		curvePanel.add(getDeleteRoadButton(), gridBagConstraints4);
    		curvePanel.add(getRoadsPanel(), gridBagConstraints6);
    		curvePanel.add(getPointsToggleButton(), gridBagConstraints5);
    	}
    	return curvePanel;
    }

	/**
     * This method initializes vehiclePanel	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getVehiclePanel() {
    	if (vehiclePanel == null) {
    		GridBagConstraints gridBagConstraints16 = new GridBagConstraints();
    		gridBagConstraints16.gridx = 0;
    		gridBagConstraints16.fill = GridBagConstraints.BOTH;
    		gridBagConstraints16.weighty = 1.0;
    		gridBagConstraints16.weightx = 1.0;
    		gridBagConstraints16.gridy = 1;
    		GridBagConstraints gridBagConstraints19 = new GridBagConstraints();
    		gridBagConstraints19.gridx = 0;
    		gridBagConstraints19.fill = GridBagConstraints.BOTH;
    		gridBagConstraints19.gridy = 3;
    		GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
    		gridBagConstraints8.gridx = 0;
    		gridBagConstraints8.fill = GridBagConstraints.BOTH;
    		gridBagConstraints8.weightx = 1.0;
    		gridBagConstraints8.weighty = 0.1;
    		gridBagConstraints8.gridy = 2;
    		GridBagConstraints gridBagConstraints14 = new GridBagConstraints();
    		gridBagConstraints14.fill = GridBagConstraints.BOTH;
    		gridBagConstraints14.gridy = 3;
    		gridBagConstraints14.weightx = 1.0;
    		gridBagConstraints14.gridx = 0;
    		GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
    		gridBagConstraints13.fill = GridBagConstraints.BOTH;
    		gridBagConstraints13.gridy = 1;
    		gridBagConstraints13.weightx = 1.0;
    		gridBagConstraints13.gridx = 0;
    		jLabel3 = new JLabel();
    		jLabel3.setText("Road:");
    		vehiclePanel = new JPanel();
    		vehiclePanel.setLayout(new GridBagLayout());
    		vehiclePanel.add(getJPanel(), gridBagConstraints8);
    		vehiclePanel.add(getJPanel1(), gridBagConstraints19);
    		vehiclePanel.add(getJPanel2(), gridBagConstraints16);
    	}
    	return vehiclePanel;
    }

	/**
     * This method initializes newRoadButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getNewRoadButton() {
    	if (newRoadButton == null) {
    		newRoadButton = new JButton();
    		newRoadButton.setText("New");
    		newRoadButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				String name = JOptionPane.showInputDialog(MainFrame.this, "Enter road name:", "");
    				
    				if ( name != null && !name.equals("") ) {
    					Core.instance.newRoad(name);		
    					updateListData();
    				}
    			}
    		});
    	}
    	return newRoadButton;
    }

	/**
     * This method initializes deleteRoadButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getDeleteRoadButton() {
    	if (deleteRoadButton == null) {
    		deleteRoadButton = new JButton();
    		deleteRoadButton.setText("Delete");
    		deleteRoadButton.setEnabled(false);
    		deleteRoadButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				if ( roadList.getSelectedIndex() != -1 ) {

    					Core.instance.deleteRoad(roadList.getSelectedIndex());
    					updateListData();
    				}
    			}
    		});
    	}
    	return deleteRoadButton;
    }

	/**
     * This method initializes roadList	
     * 	
     * @return javax.swing.JList	
     */
    private JList getRoadList() {
    	if (roadList == null) {
    		roadList = new JList();
    		roadList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    		roadList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
    			public void valueChanged(javax.swing.event.ListSelectionEvent e) {

    				if ( roadList.getSelectedIndex() != -1 ) {

    					Core.instance.switchRoad(roadList.getSelectedIndex());
    				}

    				deleteRoadButton.setEnabled(roadList.getSelectedIndex() != -1);
    				pointsToggleButton.setEnabled(roadList.getSelectedIndex() != -1);
    				
    				if ( pointsToggleButton.isSelected() ) {
    					
    					pointsToggleButton.doClick();
    				}
    			}
    		});
    	}
    	return roadList;
    }

	/**
     * This method initializes inputList	
     * 	
     * @return javax.swing.JList	
     */
    private JList getInputList() {
    	if (inputList == null) {
    		inputList = new JList();
    		inputList.setPreferredSize(new Dimension(0, 0));
    		inputList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    	}
    	return inputList;
    }

	/**
     * This method initializes roadComboBox	
     * 	
     * @return javax.swing.JComboBox	
     */
    private JComboBox getRoadComboBox() {
    	if (roadComboBox == null) {
    		roadComboBox = new JComboBox();
    		roadComboBox.setPreferredSize(new Dimension(27, 19));
    		roadComboBox.setEnabled(true);
    		roadComboBox.addItemListener(new java.awt.event.ItemListener() {
    			public void itemStateChanged(java.awt.event.ItemEvent e) {
    				
    				Core.instance.switchRoad(roadComboBox.getSelectedIndex());
    				roadList.setSelectedIndex(roadComboBox.getSelectedIndex());
    			}
    		});
    	}
    	return roadComboBox;
    }

	/**
     * This method initializes patternList	
     * 	
     * @return javax.swing.JList	
     */
    private JList getPatternList() {
    	if (patternList == null) {
    		patternList = new JList();
    		patternList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    		patternList.setSize(new Dimension(205, 250));
    		patternList
    				.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
    					public void valueChanged(javax.swing.event.ListSelectionEvent e) {
    						
    	    				if ( patternList.getSelectedIndex() != -1 ) {

    	    					Core.instance.switchPattern(patternList.getSelectedIndex());
    	    					roadComboBox.setSelectedIndex(Core.instance.session.roads.indexOf(Core.instance.selectedPattern.road));
    	    					throttleSlider.setValue((int)Math.round(Core.instance.selectedPattern.throttle * 100));
    	    					steerSlider.setValue((int)Math.round(Core.instance.selectedPattern.steer * 100));
    	        				update(null, null);
    	    				}
    	    				
    	    				deletePatternButton.setEnabled(patternList.getSelectedIndex() != -1);
    	    				throttleSlider.setEnabled(patternList.getSelectedIndex() != -1);
    	    				steerSlider.setEnabled(patternList.getSelectedIndex() != -1);
    	    				upButton.setEnabled(patternList.getSelectedIndex() != -1 && patternList.getSelectedIndex() > 0);
    	    				downButton.setEnabled(patternList.getSelectedIndex() != -1 
    	    						&& patternList.getSelectedIndex() < patternList.getModel().getSize() - 1);
    					}
    				});
    	}
    	return patternList;
    }

	/**
     * This method initializes roadsPanel	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getRoadsPanel() {
    	if (roadsPanel == null) {
    		GridBagConstraints gridBagConstraints27 = new GridBagConstraints();
    		gridBagConstraints27.fill = GridBagConstraints.BOTH;
    		gridBagConstraints27.gridy = 0;
    		gridBagConstraints27.weightx = 1.0;
    		gridBagConstraints27.weighty = 1.0;
    		gridBagConstraints27.gridx = 0;
    		roadsPanel = new JPanel();
    		roadsPanel.setLayout(new GridBagLayout());
    		roadsPanel.setBorder(BorderFactory.createTitledBorder(null, "Roads", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Microsoft Sans Serif", Font.PLAIN, 11), new Color(0, 70, 213)));
    		roadsPanel.add(getJScrollPane1(), gridBagConstraints27);
    	}
    	return roadsPanel;
    }

	/**
     * This method initializes jPanel	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJPanel() {
    	if (jPanel == null) {
    		GridBagConstraints gridBagConstraints18 = new GridBagConstraints();
    		gridBagConstraints18.gridx = 0;
    		gridBagConstraints18.insets = new Insets(3, 0, 0, 0);
    		gridBagConstraints18.fill = GridBagConstraints.HORIZONTAL;
    		gridBagConstraints18.gridwidth = 2;
    		gridBagConstraints18.gridy = 2;
    		jLabel = new JLabel();
    		jLabel.setText("Summary:");
    		GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
    		gridBagConstraints12.fill = GridBagConstraints.BOTH;
    		gridBagConstraints12.gridx = 1;
    		gridBagConstraints12.gridy = 1;
    		gridBagConstraints12.weightx = 1.0;
    		gridBagConstraints12.insets = new Insets(2, 2, 0, 0);
    		GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
    		gridBagConstraints11.fill = GridBagConstraints.HORIZONTAL;
    		gridBagConstraints11.gridy = 1;
    		gridBagConstraints11.insets = new Insets(2, 0, 0, 0);
    		gridBagConstraints11.gridx = 0;
    		GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
    		gridBagConstraints9.fill = GridBagConstraints.BOTH;
    		gridBagConstraints9.gridx = 0;
    		gridBagConstraints9.gridy = 3;
    		gridBagConstraints9.weightx = 1.0;
    		gridBagConstraints9.weighty = 1.0;
    		gridBagConstraints9.gridwidth = 2;
    		gridBagConstraints9.insets = new Insets(0, 0, 0, 0);
    		jPanel = new JPanel();
    		jPanel.setLayout(new GridBagLayout());
    		jPanel.setBorder(BorderFactory.createTitledBorder(null, "Inputs", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Microsoft Sans Serif", Font.PLAIN, 11), new Color(0, 70, 213)));
    		jPanel.setPreferredSize(new Dimension(74, 150));
    		jPanel.add(getInputList(), gridBagConstraints9);
    		jPanel.add(jLabel3, gridBagConstraints11);
    		jPanel.add(getRoadComboBox(), gridBagConstraints12);
    		jPanel.add(jLabel, gridBagConstraints18);
    	}
    	return jPanel;
    }

	/**
     * This method initializes jPanel1	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJPanel1() {
    	if (jPanel1 == null) {
    		GridBagConstraints gridBagConstraints30 = new GridBagConstraints();
    		gridBagConstraints30.gridx = 2;
    		gridBagConstraints30.anchor = GridBagConstraints.EAST;
    		gridBagConstraints30.gridy = 4;
    		jLabel7 = new JLabel();
    		jLabel7.setText("Right");
    		GridBagConstraints gridBagConstraints29 = new GridBagConstraints();
    		gridBagConstraints29.gridx = 0;
    		gridBagConstraints29.gridy = 4;
    		jLabel6 = new JLabel();
    		jLabel6.setText("Left");
    		GridBagConstraints gridBagConstraints28 = new GridBagConstraints();
    		gridBagConstraints28.gridx = 2;
    		gridBagConstraints28.anchor = GridBagConstraints.EAST;
    		gridBagConstraints28.gridy = 1;
    		jLabel5 = new JLabel();
    		jLabel5.setText("Accelerate");
    		GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
    		gridBagConstraints7.gridx = 0;
    		gridBagConstraints7.anchor = GridBagConstraints.WEST;
    		gridBagConstraints7.gridy = 1;
    		jLabel1 = new JLabel();
    		jLabel1.setText("Break");
    		GridBagConstraints gridBagConstraints23 = new GridBagConstraints();
    		gridBagConstraints23.fill = GridBagConstraints.BOTH;
    		gridBagConstraints23.gridy = 5;
    		gridBagConstraints23.weightx = 1.0;
    		gridBagConstraints23.gridwidth = 3;
    		gridBagConstraints23.gridx = 0;
    		GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
    		gridBagConstraints22.fill = GridBagConstraints.BOTH;
    		gridBagConstraints22.gridy = 2;
    		gridBagConstraints22.weightx = 1.0;
    		gridBagConstraints22.gridwidth = 3;
    		gridBagConstraints22.gridx = 0;
    		GridBagConstraints gridBagConstraints15 = new GridBagConstraints();
    		gridBagConstraints15.anchor = GridBagConstraints.CENTER;
    		gridBagConstraints15.insets = new Insets(3, 0, 0, 0);
    		gridBagConstraints15.gridx = 0;
    		gridBagConstraints15.gridy = 3;
    		gridBagConstraints15.gridwidth = 3;
    		gridBagConstraints15.fill = GridBagConstraints.NONE;
    		GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
    		gridBagConstraints10.fill = GridBagConstraints.NONE;
    		gridBagConstraints10.gridx = 0;
    		gridBagConstraints10.gridy = 0;
    		gridBagConstraints10.weightx = 0.0;
    		gridBagConstraints10.anchor = GridBagConstraints.CENTER;
    		gridBagConstraints10.gridwidth = 3;
    		gridBagConstraints10.insets = new Insets(0, 0, 0, 0);
    		jPanel1 = new JPanel();
    		jPanel1.setLayout(new GridBagLayout());
    		jPanel1.setBorder(BorderFactory.createTitledBorder(null, "Outputs", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Microsoft Sans Serif", Font.PLAIN, 11), new Color(0, 70, 213)));
    		jPanel1.add(jLabel2, gridBagConstraints10);
    		jPanel1.add(jLabel4, gridBagConstraints15);
    		jPanel1.add(getThrottleSlider(), gridBagConstraints22);
    		jPanel1.add(getSteerSlider(), gridBagConstraints23);
    		jPanel1.add(jLabel1, gridBagConstraints7);
    		jPanel1.add(jLabel5, gridBagConstraints28);
    		jPanel1.add(jLabel6, gridBagConstraints29);
    		jPanel1.add(jLabel7, gridBagConstraints30);
    	}
    	return jPanel1;
    }

	/**
     * This method initializes jPanel2	
     * 	
     * @return javax.swing.JPanel	
     */
    private JPanel getJPanel2() {
    	if (jPanel2 == null) {
    		GridBagConstraints gridBagConstraints31 = new GridBagConstraints();
    		gridBagConstraints31.fill = GridBagConstraints.BOTH;
    		gridBagConstraints31.gridy = 0;
    		gridBagConstraints31.weightx = 1.0;
    		gridBagConstraints31.gridwidth = 2;
    		gridBagConstraints31.weighty = 0.0;
    		gridBagConstraints31.gridx = 1;
    		GridBagConstraints gridBagConstraints26 = new GridBagConstraints();
    		gridBagConstraints26.gridx = 1;
    		gridBagConstraints26.fill = GridBagConstraints.BOTH;
    		gridBagConstraints26.weightx = 0.5;
    		gridBagConstraints26.gridy = 4;
    		GridBagConstraints gridBagConstraints25 = new GridBagConstraints();
    		gridBagConstraints25.gridx = 2;
    		gridBagConstraints25.fill = GridBagConstraints.HORIZONTAL;
    		gridBagConstraints25.weightx = 0.5;
    		gridBagConstraints25.gridy = 4;
    		GridBagConstraints gridBagConstraints17 = new GridBagConstraints();
    		gridBagConstraints17.gridx = 1;
    		gridBagConstraints17.fill = GridBagConstraints.HORIZONTAL;
    		gridBagConstraints17.gridy = 5;
    		GridBagConstraints gridBagConstraints24 = new GridBagConstraints();
    		gridBagConstraints24.fill = GridBagConstraints.BOTH;
    		gridBagConstraints24.gridy = 2;
    		gridBagConstraints24.weightx = 1.0;
    		gridBagConstraints24.weighty = 1.0;
    		gridBagConstraints24.gridwidth = 2;
    		gridBagConstraints24.insets = new Insets(3, 0, 3, 0);
    		gridBagConstraints24.gridx = 1;
    		jPanel2 = new JPanel();
    		jPanel2.setLayout(new GridBagLayout());
    		jPanel2.setBorder(BorderFactory.createTitledBorder(null, "Patterns", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, new Font("Microsoft Sans Serif", Font.PLAIN, 11), new Color(0, 70, 213)));
    		jPanel2.add(getJScrollPane(), gridBagConstraints24);
    		jPanel2.add(getExportButton(), gridBagConstraints17);
    		jPanel2.add(getSaveButton(), gridBagConstraints25);
    		jPanel2.add(getOpenButton(), gridBagConstraints26);
    		jPanel2.add(getJToolBar(), gridBagConstraints31);
    	}
    	return jPanel2;
    }

	/**
     * This method initializes newPatternButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getNewPatternButton() {
    	if (newPatternButton == null) {
    		newPatternButton = new JButton();
    		newPatternButton.setText("");
    		newPatternButton.setIcon(new ImageIcon(getClass().getResource("/resources/new_wiz.gif")));
    		newPatternButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				if ( Core.instance.newPattern() ) {
    					
    					patternList.setListData(Core.instance.session.patterns.toArray());
    					patternList.setSelectedIndex(Core.instance.session.patterns.size() - 1);
    				}
    				else {
    					
    					JOptionPane.showMessageDialog(MainFrame.this, "Valid road not selected", "Warning", JOptionPane.WARNING_MESSAGE);
    				}
    			}
    		});
    	}
    	return newPatternButton;
    }

	/**
     * This method initializes deletePatternButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getDeletePatternButton() {
    	if (deletePatternButton == null) {
    		deletePatternButton = new JButton();
    		deletePatternButton.setText("");
    		deletePatternButton.setIcon(new ImageIcon(getClass().getResource("/resources/delete_edit.gif")));
    		deletePatternButton.setEnabled(false);
    		deletePatternButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				if ( patternList.getSelectedIndex() != -1) {
    				
    					Core.instance.deletePattern(patternList.getSelectedIndex());
    					
    					patternList.setListData(Core.instance.session.patterns.toArray());
    					paintBox.repaint();
    				}
    			}
    		});
    	}
    	return deletePatternButton;
    }

	/**
     * This method initializes throttleSlider	
     * 	
     * @return javax.swing.JSlider	
     */
    private JSlider getThrottleSlider() {
    	if (throttleSlider == null) {
    		throttleSlider = new JSlider();
    		throttleSlider.setValue(50);
    		throttleSlider.setMajorTickSpacing(25);
    		throttleSlider.setMinorTickSpacing(5);
    		throttleSlider.setMaximum(100);
    		throttleSlider.setEnabled(false);
    		throttleSlider.setPaintTicks(true);
    		throttleSlider.addChangeListener(new javax.swing.event.ChangeListener() {
    			public void stateChanged(javax.swing.event.ChangeEvent e) {
    				
    				if ( Core.instance.selectedPattern != null) {
    					
    					Core.instance.selectedPattern.throttle = (double)throttleSlider.getValue() / 100;
    				}
    			}
    		});
    	}
    	return throttleSlider;
    }

	/**
     * This method initializes steerSlider	
     * 	
     * @return javax.swing.JSlider	
     */
    private JSlider getSteerSlider() {
    	if (steerSlider == null) {
    		steerSlider = new JSlider();
    		steerSlider.setMajorTickSpacing(50);
    		steerSlider.setPaintTicks(true);
    		steerSlider.setValue(50);
    		steerSlider.setEnabled(false);
    		steerSlider.setMinorTickSpacing(5);
    		steerSlider.addChangeListener(new javax.swing.event.ChangeListener() {
    			public void stateChanged(javax.swing.event.ChangeEvent e) {

    				if ( Core.instance.selectedPattern != null) {

    					Core.instance.selectedPattern.steer = (double)steerSlider.getValue() / 100;
    				}
    			}
    		});
    	}
    	return steerSlider;
    }

	/**
     * This method initializes jScrollPane	
     * 	
     * @return javax.swing.JScrollPane	
     */
    private JScrollPane getJScrollPane() {
    	if (jScrollPane == null) {
    		jScrollPane = new JScrollPane();
    		jScrollPane.setPreferredSize(new Dimension(275, 250));
    		jScrollPane.setViewportView(getPatternList());
    		jScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    		jScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    		jScrollPane.setViewportView(getPatternList());
    	}
    	return jScrollPane;
    }

	/**
     * This method initializes exportButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getExportButton() {
    	if (exportButton == null) {
    		exportButton = new JButton();
    		exportButton.setText("Export...");
    		exportButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				ExportOptions exportOptions = new ExportOptions();
    				fileChooser.setDialogTitle("Export session");
    				fileChooser.setAccessory(exportOptions);
					int returnVal = fileChooser.showSaveDialog(MainFrame.this);

			        if (returnVal == JFileChooser.APPROVE_OPTION) {
			            File file = fileChooser.getSelectedFile();
			            
			            Core.instance.exportSession(file, exportOptions.getMirrorCheckBox().isSelected(), 
			            		exportOptions.getRandomizeCheckBox().isSelected());
			        }
			        fileChooser.setAccessory(null);
    			}
    		});
    	}
    	return exportButton;
    }

	/**
     * This method initializes saveButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getSaveButton() {
    	if (saveButton == null) {
    		saveButton = new JButton();
    		saveButton.setText("Open...");
    		saveButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				fileChooser.setDialogTitle("Open session");
					int returnVal = fileChooser.showOpenDialog(MainFrame.this);

			        if (returnVal == JFileChooser.APPROVE_OPTION) {
			            File file = fileChooser.getSelectedFile();
			            
			            Core.instance.loadSession(file);
			        }
    			}
    		});
    	}
    	return saveButton;
    }

	/**
     * This method initializes OpenButton	
     * 	
     * @return javax.swing.JButton	
     */
    private JButton getOpenButton() {
    	if (OpenButton == null) {
    		OpenButton = new JButton();
    		OpenButton.setText("Save...");
    		OpenButton.addActionListener(new java.awt.event.ActionListener() {
    			public void actionPerformed(java.awt.event.ActionEvent e) {
    				
    				fileChooser.setDialogTitle("Save session");
					int returnVal = fileChooser.showSaveDialog(MainFrame.this);

			        if (returnVal == JFileChooser.APPROVE_OPTION) {
			            File file = fileChooser.getSelectedFile();
			            
			            Core.instance.saveSession(file);
			        }
    			}
    		});
    	}
    	return OpenButton;
    }

	/**
     * This method initializes jScrollPane1	
     * 	
     * @return javax.swing.JScrollPane	
     */
    private JScrollPane getJScrollPane1() {
    	if (jScrollPane1 == null) {
    		jScrollPane1 = new JScrollPane();
    		jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    		jScrollPane1.setViewportView(getRoadList());
    		jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    	}
    	return jScrollPane1;
    }

	/**
	 * This method initializes pointsToggleButton	
	 * 	
	 * @return javax.swing.JToggleButton	
	 */
	private JToggleButton getPointsToggleButton() {
		if (pointsToggleButton == null) {
			pointsToggleButton = new JToggleButton();
			pointsToggleButton.setText("Points");
			pointsToggleButton.setEnabled(false);
			pointsToggleButton.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(java.awt.event.ItemEvent e) {
					
					Core.instance.isPointEditing = pointsToggleButton.isSelected();
				}
			});
		}
		return pointsToggleButton;
	}

	public void updateListData() {
		
		MainFrame.this.roadList.setListData(Core.instance.session.roads.toArray());
		Utils.setListData(MainFrame.this.roadComboBox,Core.instance.session.roads.toArray());
		
		MainFrame.this.patternList.setListData(Core.instance.session.patterns.toArray());
	}

	/**
	 * This method initializes jToolBar	
	 * 	
	 * @return javax.swing.JToolBar	
	 */
	private JToolBar getJToolBar() {
		if (jToolBar == null) {
			jToolBar = new JToolBar();
			jToolBar.setFloatable(false);
			jToolBar.add(getNewPatternButton());
			jToolBar.add(getDeletePatternButton());
			jToolBar.add(getUpButton());
			jToolBar.add(getDownButton());
		}
		return jToolBar;
	}

	/**
	 * This method initializes upButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getUpButton() {
		if (upButton == null) {
			upButton = new JButton();
			upButton.setIcon(new ImageIcon(getClass().getResource("/resources/up.gif")));
			upButton.setEnabled(false);
			upButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					Core.instance.movePattern(-1);
					patternList.setListData(Core.instance.session.patterns.toArray());
					patternList.setSelectedIndex(Core.instance.session.patterns.indexOf(Core.instance.selectedPattern));
				}
			});
		}
		return upButton;
	}

	/**
	 * This method initializes downButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getDownButton() {
		if (downButton == null) {
			downButton = new JButton();
			downButton.setIcon(new ImageIcon(getClass().getResource("/resources/down.gif")));
			downButton.setEnabled(false);
			downButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					Core.instance.movePattern(1);
					patternList.setListData(Core.instance.session.patterns.toArray());
					patternList.setSelectedIndex(Core.instance.session.patterns.indexOf(Core.instance.selectedPattern));
				}
			});
		}
		return downButton;
	}

	/**
	 * This method initializes jSlider	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSlider() {
		if (jSlider == null) {
			jSlider = new JSlider();
		}
		return jSlider;
	}

	/**
	 * This method initializes zoomSlider	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getZoomSlider() {
		if (zoomSlider == null) {
			zoomSlider = new JSlider();
			zoomSlider.setValue(100);
			zoomSlider.addChangeListener(new javax.swing.event.ChangeListener() {
				public void stateChanged(javax.swing.event.ChangeEvent e) {
					
					double zoom = ((double)zoomSlider.getValue() / 100) * 0.8 + 0.2;
					Core.instance.paintBox.setZoom(zoom);
					
					Core.instance.paintBox.repaint();
				}
			});
		}
		return zoomSlider;
	}
}
